#define MCU 16F1847

/*
  FOSC interne 16Mhz
CONFIG1 : $8007 : 0x39E4
CONFIG2 : $8008 : 0x1613
*/





#define Version "161109"

#define Directory " C:\\_MikroC\\_MesProjets_MikroC\\_NRF24L01\Tx"
#define Project " PIC16F1847_TX.mcppi"
#define Source " PIC TX_16F1847_"
#define Module_NRF24L01

#define Oscillateur_Interne
#define MCU 16F1827
// Power_Supply 3,3V
// config 16MHZ FOSC interne
//CONFIG1 : $8007 : 0x39E4
//CONFIG2 : $8008 : 0x1613


   //-- commandes terminal VT220
#define CLS 12     // effacement de page sur Terminal VBRAY
#define CR 13
#define VT 10
#define LF 10
#define TAB 9
#define BELL 7
#define Byte unsigned char
#define uint8 unsigned char

 //ac:NRFlinksToPIC       // interconnection NRDF et PIC

// liaison UART
//  RB1 Rx UART <----- clavier fil vert  cordon Prolix LTTL/USB PC  Teraterm.exe
//  RB5 Tx UART -----> Ecran   fil blanc cordon Prolix LTTL/USB PC  Teraterm.exe

// liaison module NRF24L01
// NRF                    PIC16F
// 1  Gnd    noir           0V Gnd
// 2  +V     rouge           +3,3V
// 3  CE     marron          RB6
// 4  CSN    Blanc           RB7
// 5  SCK    Bleu            RB4 SCK
// 6  MOSI   Jaune           RA6 MOSI
// 7  MISO   Vert            RB1 MISO
// 8  IRQ    Vilolet         Non connect

 /*
 microcontroller supports SPI
sbit Irq_pin   at PORTB.B0;
sbit Ce_pin    at LATB.B6 ;
sbit Csn_pin   at LATB.B7;

sbit Irq_tris_direction   at TRISB.B0;
sbit Ce_tris_direction  at TRISB.B6 ;
sbit Csn_tris_direction  at TRISB.B7;
 */

sbit Led at LATB.B2 ;
sbit Led_Direction at TRISB.B2;

sbit IRQ_TRIS at TRISB0_bit;
sbit CSN_TRIS at TRISB7_bit;
sbit CE_TRIS at TRISB6_bit;
sbit SCK_TRIS at TRISB4_bit;
sbit SDI_TRIS at TRISB1_bit;
sbit SDO_TRIS at TRISA6_bit;

sbit IRQ_pin at PORTB.B0; //No puede ser RB0 o RB1 por que son para SPI
sbit CSN_pin at LATB7_bit;
sbit CE_pin at LATB6_bit;
sbit SCK_pin at LATB4_bit;
sbit MOSI_pin at LATA6_bit; //SDO Escritura Salida
sbit MISO_pin at PORTB.B1; //SDI Lectura Entrada


#define R_REGISTER_cmd                0x00
#define W_REGISTER_cmd                0x20
#define R_RX_PL_WID_cmd               0x60
#define R_RX_PAYLOAD_cmd              0x61
#define W_TX_PAYLOAD_cmd              0xA0
#define W_ACK_PAYLOAD_cmd             0xA8
#define W_TX_PAYLOAD_NO_ACK_cmd       0xB0
#define FLUSH_TX_cmd                  0xE1
#define FLUSH_RX_cmd                  0xE2
#define REUSE_TX_PL_cmd               0xE3
#define NOP_cmd                       0xFF

#define CONFIG_reg                    0x00
#define EN_AA_reg                     0x01
#define EN_RXADDR_reg                 0x02
#define SETUP_AW_reg                  0x03
#define SETUP_RETR_reg                0x04
#define RF_CH_reg                     0x05
#define RF_SETUP_reg                  0x06
#define STATUS_reg                    0x07
#define OBSERVE_TX_reg                0x08
#define RPD_reg                       0x09
#define RX_ADDR_P0_reg                0x0A
#define RX_ADDR_P1_reg                0x0B
#define RX_ADDR_P2_reg                0x0C
#define RX_ADDR_P3_reg                0x0D
#define RX_ADDR_P4_reg                0x0E
#define RX_ADDR_P5_reg                0x0F
#define TX_ADDR_reg                   0x10
#define RX_PW_P0_reg                  0x11
#define RX_PW_P1_reg                  0x12
#define RX_PW_P2_reg                  0x13
#define RX_PW_P3_reg                  0x14
#define RX_PW_P4_reg                  0x15
#define RX_PW_P5_reg                  0x16
#define FIFO_STATUS_reg               0x17
#define DYNPD_reg                     0x1C
#define FEATURE_reg                   0x1D




unsigned char Texte[80];
unsigned char CRam1[32];
int i,j,k;
unsigned char dummy;
short dataLength = 20;

unsigned char x = 0;
unsigned char val = 0;


void CRLF1()
{
 UART1_Write(CR);
 UART1_Write(LF);
}


void UART1_Write_CText(const char *txt) {
   while (*txt)
      UART1_Write(*txt++);
}





unsigned char nRF24L01_read()
{
  unsigned char s = 0;
  unsigned char msg = 0;

  for(s = 0; s < 8; s++)
  {
      msg <<= 1;
      SCK_pin = 1;
      Delay_us(8);
      if(MISO_pin != 0)
      {
        msg |= 1;
      }
      SCK_pin = 0;
      Delay_us(8);
  }

  return msg;
}


void nRF24L01_write(unsigned char d)
{
  unsigned char s = 0;

  for(s = 0; s < 8; s++)
  {
    if((d & 0x80) != 0)
    {
      MOSI_pin = 1;
    }
    else
    {
      MOSI_pin = 0;
    }
    d <<= 1;
    SCK_pin = 1;
    Delay_us(8);
    SCK_pin = 0;
    Delay_us(8);
  }
}


void register_write(unsigned char reg, unsigned char value)
{
  CSN_pin = 0;
  nRF24L01_write((reg | W_REGISTER_cmd));
  nRF24L01_write(value);
  CSN_pin = 1;
  Delay_us(8);
}


void write_command(unsigned char cmd)
{
  CSN_pin = 0;
  nRF24L01_write(cmd);
  CSN_pin = 1;
  Delay_us(8);
}


unsigned char register_read(unsigned char reg)
{
  unsigned char value = 0;

  CSN_pin = 0;
  nRF24L01_write((reg | R_REGISTER_cmd));
  value = nRF24L01_read();
  CSN_pin = 1;
  Delay_us(8);

  return value;
}


void set_TX_RX_address(unsigned char *addr, unsigned char bytes, unsigned char reg)
{
  unsigned char n = 0;

  CSN_pin = 0;
  nRF24L01_write((reg | W_REGISTER_cmd));
  for(n = 0; n < bytes; n++)
  {
    nRF24L01_write(addr[n]);
  }
  CSN_pin = 1;
  Delay_us(8);
}


void flush_TX_RX()
{
  register_write(STATUS_reg, 0x70);
  write_command(FLUSH_TX_cmd);
  write_command(FLUSH_RX_cmd);
}


void send_data(unsigned char bytes, unsigned char *value)
{
  unsigned char s = 0;

  flush_TX_RX();
  register_write(CONFIG_reg, 0x3A);

  CSN_pin = 0;
  nRF24L01_write(W_TX_PAYLOAD_cmd);
  for(s = 0; s < bytes; s++)
  {
    nRF24L01_write(value[s]);
  }
  CSN_pin = 1;
  Delay_us(8);

  CE_pin = 1;
  Delay_us(60);
  CE_pin = 0;

  register_write(CONFIG_reg, 0x38); //En modo RX se quita
}

void receive_data(unsigned char bytes, unsigned char *value)
{
  unsigned char s = 0;

  CSN_pin = 0;
  nRF24L01_write(R_RX_PAYLOAD_cmd);
  for (s = 0; s < bytes; s++)
  {
    value[s] = nRF24L01_read();
  }
  CSN_pin = 1;
  Delay_us(8);
}


void nrF24L01_init_TX()
{
  unsigned char address[5] = {0x99, 0x99, 0x99, 0x99, 0x99};

  CE_pin = 0;

  register_write(SETUP_RETR_reg, 0x00);
  register_write(SETUP_AW_reg, 0x03);
  register_write(RF_SETUP_reg, 0x0E);
  register_write(RF_CH_reg, 0x09);
  register_write(EN_AA_reg, 0x00);
  register_write(CONFIG_reg, 0x38);
  set_TX_RX_address(address, 5, TX_ADDR_reg);
  set_TX_RX_address(address, 5, RX_ADDR_P0_reg);
  flush_TX_RX();

  CE_pin = 1;
}

void nrF24L01_init_RX()
{
  unsigned char address[5] = {0x99, 0x99, 0x99, 0x99, 0x99};

  CE_pin = 0;

  register_write(CONFIG_reg, 0x38);
  register_write(SETUP_RETR_reg, 0x00);
  register_write(SETUP_AW_reg, 0x03);
  register_write(RF_SETUP_reg, 0x0E);
  register_write(RF_CH_reg, 0x09);
  register_write(EN_AA_reg, 0x00);
  register_write(RX_PW_P0_reg, 0x01);
  register_write(CONFIG_reg, 0x3B);
  set_TX_RX_address(address, 5, TX_ADDR_reg);
  set_TX_RX_address(address, 5, RX_ADDR_P0_reg);
  flush_TX_RX();

  CE_pin = 1;
}

unsigned char get_Status_Reg()
{
  return register_read(STATUS_reg);
}






 void Init_Hardware()
{
 PORTA=0x00;
 PORTB=0x00;
 ANSELA = 0;  // Mise du portA en mode digital I/O
 TRISA=0b10111111;  // all input   except RA6 en sortie ( MOSI)

 ANSELB = 0;         //Mise du portB en mode digital I/O
// RB2 en sortie (Led) , RB7 en sortie (CNSS)  RB4 en sortie ( SPI Clock)  RB1 en entre (MISO)
 TRISB=0b00101011;
 Led_Direction=0;


 APFCON0=0;  // ALTERNATE PIN FUNCTION CONTROL REGISTER 0// page 119
 APFCON0.RXDTSEL=0; // RXDTSEL=1  RX/DT function is on RB1
 APFCON0.SDO1SEL = 1 ; // SDO sur RA6 MOSI// SDO1SEL=0  SDO1 function is on RB2
// RXDTSEL= 0 = RX/DT function is on RB1 ,  1 = RX/DT function is on RB2
 // SS1SEL =0  SS1 function is on RB5
 // P2BSEL =0  P2B function is on RB7
 // CCP2SEL =0 CCP2/P2A function is on RB6
 // P1DSEL= 0  P1D function is on RB7
 // P1CSEL= 0  P1C function is on RB6
 // CCP1SEL= 0 CCP1/P1A function is on RB3
// APFCON1=0; // non implment sur 16f1827
 //APFCON1bits.TXCKSEL=0; //  TX/CK function is on RB2
 //APFCON1.SDO1SEL= 1; //0 = SDO1 function is on RB2    1 = SDO1 function is on RA6
APFCON1.TXCKSEL=1;   // TXCKSEL=0 choix RB2 (par defaut)  TXCKSEL=1 choix RB5, car RB2 sur Led

 CM1CON0=0;       // disable comparators
 CM1CON1=0;
 //MDCARH.MDCHODIS=1; //0 = Output signal driving the peripheral output pin (selected by MDCH<3:0>) is disabled
 //MDCARL.MDCLODIS=1; //1 = Output signal driving the peripheral output pin (selected by MDCL<3:0>  is disabled

 FVRCON.FVREN=0;  // disble fixed voltage reference
 EECON1.EEPGD=0;  // is the control register for EE memorya Accesses.
 // Option REG
 //  /WPUEN INTEDG TMR0CS TMR0SE PSA PS<2:0>
 OPTION_REG=0;    //0 = Weak pull-ups are enabled by individual WPUx latch values
// Note 1: Global WPUEN bit of the OPTION_REG register must be cleared for individual pull-ups to be enabled.
//2: The weak pull-up device is automatically disabled if the pin is in configured as an output.
//If MCLRE in Configuration Word 1 = 1, MCLR is enabled):
// Weak Pull-up is always enabled.

  //INTCON GIE PEIE TMR0IE INTE IOCE TMR0IF INTF IOCF
  INTCON = 0;
 // PIE1
 //TMR1GIE ADIE RCIE TXIE SSP1IE CCP1IE TMR2IE TMR1IE
 PIE1=0;  // deja a zero sur reset
// PIR1: PERIPHERAL INTERRUPT REQUEST REGISTER 1
// TMR1GIF ADIF RCIF TXIF SSP1IF CCP1IF TMR2IF TMR1IF
 PIR1=0;    // deja a zero sur reset
 //   INTCON GIE PEIE TMR0IE INTE IOCE TMR0IF INTF IOCF p89
 INTCON.IOCIE = 0 ;  // disable interrupt PORTB
 INTCON.GIE = 0 ;
}



void main()
{
 // OSCCON: OSCILLATOR CONTROL REGISTER
// bit 7 SPLLEN: Software PLL Enable bit
//If PLLEN in Configuration Word 1 = 1:
// SPLLEN bit is ignored. 4x PLL is always enabled (subject to oscillator requirements)
// If PLLEN in Configuration Word 1 = 0:
// 1 = 4x PLL Is enabled
// 0 = 4x PLL is disabled
//bit 6-3 IRCF<3:0>: Internal Oscillator Frequency Select bits
//1111 = 16 MHz HF
//bit 2=0
//bit 1-0  SCS<1:0>: System Clock Select bits
//1x = Internal oscillator block
//01 = Timer1 oscillator
//00 = Clock determined by FOSC<2:0> in Configuration Word 1.
   OSCCON = 0b01111010 ; // 16 mhz oscilateur interne
   OSCTUNE=0;

   Init_Hardware();


  UART1_Init(19200);
   UART1_Write(CLS);
   Delay_ms(500);

   UART1_Write_CText(" Directory: "Directory"\r\n");
   UART1_Write_CText(" Projet: "Project"\r\n");
   UART1_Write_CText(" Source : "Source"_"Version".c\r\n");
   UART1_Write_CText(" UART1 19200,8,N,1  ->Display terminal\r\n");
   UART1_Write_CText(" FOSC = ");
   UART1_Write_CText("\r\nTest NRF24L01 with PIC16F1847 avec SPI Software !\r\n");


 IRQ_TRIS = 1;
 CSN_TRIS = 0;
 CE_TRIS = 0;
 SCK_TRIS = 0;
 SDI_TRIS = 1;  //MISO
 SDO_TRIS = 0;  //MOSI

 CE_pin = 0;
 CSN_pin = 1;
 SCK_pin = 0;
 MOSI_pin = 0;

 Delay_ms(1000);


 nrF24L01_init_TX();

 Delay_ms(900);

  i=0;
  x=65;
 while(1)
 {
  UART1_Write_CText("Data Send :  ");
  send_data(1, &x);
  ByteToStr(x,CRam1);
  UART1_Write_Text(CRam1);CRLF1();
  i++;
  if (i>32) i=0;
  x++;
  if (i>95) x=65;
  Delay_ms(1000);
 }
}
/*



 Directory:  C:\_MikroC\_MesProjets_MikroC\_NRF24L01Tx
 Projet:  PIC16F1847_TX.mcppi
 Source :  PIC TX_16F1847__161109.c
 UART1 19200,8,N,1  ->Display terminal
 FOSC =
Test NRF24L01 with PIC16F1847 avec SPI Software !
Data Send :   65
Data Send :   66
Data Send :   67
Data Send :   68
Data Send :   69
Data Send :   70
Data Send :   71
Data Send :   72
Data Send :   73

*/